import java.util.*;
import java.io.*;

/*
 * This solution uses a TwoCharStack object.
 * This is a two-ring char buffer that 
 * is constantly pushing characters from a reader 
 * while popping characters into a writer.
 *
 * Certainly not the most elegant implementation,
 * but it works.
 *
 * Improvements: use a stack.
 * Originallky planned to implement a data structure,
 * but that morphed into a mutant data structure/problem solution object.
 * who has responsibility to load and manage reading char by char?
 * put go() into main method.
 * but now you are getting messy. sharing a reader.
 *
 * want to create file reader writer,
 * then  say go w/o having to worry abt implem dets
 * like... calling one method first,
 * then calling push method on remaining chars
 * plus it has to manage and call reader anyway, 
 * why not do it all in 1 place
 */

public class Preprocessor {
	public static void main(String[] args) throws FileNotFoundException { 
		BufferedReader reader = null;
		BufferedWriter writer = null;

		try {
		    File file = new File("E-tiny.in");
		    reader = new BufferedReader(new FileReader(file));

		    File outfile = new File("E-lead.out");
		    writer = new BufferedWriter(new FileWriter(outfile));

			TwoCharStack t = new TwoCharStack(reader,writer);
			t.go();

		} catch (IOException e) {
		    e.printStackTrace();
		} finally {
			try{
				reader.close();
				writer.close();
			} catch (IOException e) { 
				e.printStackTrace();
			}
		}
	}
}

class TwoCharStack {
	private char[] data;
	private int nestLevel;
	private BufferedReader reader;
	private BufferedWriter writer; 

	public TwoCharStack(BufferedReader reader, BufferedWriter writer) {
		this.reader = reader;
		this.writer = writer;
		this.data = new char[2];
		this.nestLevel = 0;
	}

	public void go() throws IOException {
		printCase(1);

		// almost forgot... initially data[] is empty.
		readIntoEmptyCharStack();

		int c;
		while((c = reader.read()) != -1) {
			push((char)c);
		}
	}

	public void printCase(int caseno) throws IOException {
		// this whole chunk took some effort to figure out.
		// key was the .toCharArray() method,
		// and the String.valueOf() method,
		// useful for converting from String --> BufferedWriter
		String s = "Case #"+caseno+":";
		for(char c : s.toCharArray() ) {
			writer.write((int)c);
		}
		writer.write(String.valueOf("\n"));
	}

	public void push(char c) throws IOException {
		// only write if we are not in a comment
		if(nestLevel==0) {
			writer.write((int)data[0]);
		}
		data[0] = data[1];
		data[1] = c; 
		while( holdingComment() && nestLevel >= 0 ) { 
			readIntoEmptyCharStack();
		}
	}

	public boolean holdingComment() {
		boolean openComment = (data[0]=='/' && data[1]=='*');
		boolean closeComment = (data[0]=='*' && data[1]=='/');

		// this if/else clause was also a bit tricky.
		// the test includes a comment like *******/****
		// at the beginning to check if you are removing comments
		// that haven't been opened.
		if(closeComment) { 
			if(nestLevel>0) {
				nestLevel--;
				return true;
			}
		} else if(openComment) {
			nestLevel++;
			return true;
		}
		return false;
	}

	public void readIntoEmptyCharStack() throws IOException {
		for(int i=0; i<2; i++) { 
			int c = reader.read();
			if( c != -1) {
				data[i] = (char)c;
			}
		}
	}
}

