# Ignore My Comments

[link](https://codejam.withgoogle.com/codejam/contest/2929486/dashboard#s=p4)

Igor likes C style comments `/* ... */` 

Write a preprocessor that will remove this style of comment
from his source code, no matter what the language.

Other cool things the preprocessor does:
* Comments can be nested like brackets,


printf("Hello /* a comment /* a comment inside comment */ 
        inside /* another comment inside comment */ 
        string */ world");

After the pre-process step, it becomes:

printf("Hello  world");


Comments can appear anywhere,
including inside of Strings:

`"/*...*/"`

or inside of a number

`12/*...*/34`

or even inside a character escape:

`\/*...*/n`


More formally:

```
text:
  text-piece
  text-piece remaining-text
text-piece:
  char-sequence-without-/*
  empty-string
remaining-text:
  comment-block text

comment-block:
  /* comment-content */
comment-content:
  comment-piece
  comment-piece remaining-comment
comment-piece:
  char-sequence-without-/*-or-*/
  empty-string
remaining-comment:
  comment-block comment-content

char:
  letters
  digits
  punctuations
  whitespaces
```

Our pre-processor, given a text, removes all comment-block instances as specified.

Igor only needs to remove the comment in one pass. He doesn't remove additional comment blocks created as a result of the removal of any comment block. For example:

```
	//*no recursion*/* file header */
```

should generate:

```
	/* file header */
```


The * character in any /* or /*cannot be re-used in another /* or */. 

This does not form proper comment block: 

```
	/*/
```
























